#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>

/* prototip pomocne funkcije za qsort funkciju. */
int sort(const void *x, const void *y);

int main(void) {

	/* deklaracija cjelobrojnog pokazivaca. */
	int *numbers=NULL;

	/* deklaracija varijable input za ucitanu cjelobrojnu vrijednost
	i deklaracija varijable result za provjeru scanf (da li je ucitana cjelobrojna vrijednost)*/
	int input, result;

	/* size je pocetna velicina dinamicki alociranog bloka, 
	index nam govori koji je prvi slobodni element u bloku
	i je brojac za for petlju*/
	
	int size = 4;
	int i, index = 0;

	/* inicijalno alociranje memorije. */
	numbers = (int *) malloc(size * sizeof(int));

	/* Nismo provjerili da li je alociranje uspjelo. */

	/* beskonacna petlja koja se prekida kad
	korisnik unese 0 ili
	korisnik ne unese cjelobrojnu vrijednost*/
	while (1) {

		/* upit */
		printf("Upisi cijeli broj razlicit od 0 (ili 0 za izlazak): ");
		result = scanf("%d", &input);

		/* ako je 0 ili ako nije cijeli broj, izlazimo iz while */
		if (result < 1 || input == 0) break;

		/* Provjera da li imamo dovoljno dinamicki alocirane memorije. 
		Ako ne, zovemo realloc() da se poveca 1.5x */
		if (index == size) {
			size = size*1.5;
			numbers = (int *) realloc(numbers, size * sizeof(int));
			printf("Realokacija memorijskog bloka. Sada je velicina %d bajta.\n", size);
		}

		/* Pospremi cjelobrojnu vrijednost u prvi slobodan element. */
		numbers[index] = input;

		/* index se poveca za 1 kako bi znali sljedece slobodno mjesto za upis. */
		index++;

	} /* kraj while petlje. */


	  /* poziv funkcije qsort() za uzlazno sortiranje . */
	qsort(numbers, index, sizeof(int), sort);


	/* ispis brojeva u petlji. */
	for (i = 0; i < index; i++) {
		printf("Vrijednost na mjestu %d je %d.\n", i, numbers[i]);
	}


	/* oslobadanje memorije. */
	free(numbers);
	numbers = NULL;

	system("pause.exe");
	return 0;

} /* kraj main() funkcije. */


  /* pomocna sort funkcija za qsort */
int sort(const void * a, const void * b) {

	return (*(int*)a - *(int*)b);

} /* kraj sort() funkcije. */