#include <iostream>
//#include <stdlib.h>
#include <windows.h>
using namespace std;

/* prototip pomocne funkcije za qsort funkciju. */
int sort(const void *x, const void *y);

int main(void) {

	/* deklaracija cjelobrojnog pokazivaca. */
	int *numbers=NULL, *numbers_old=NULL;

	/* deklaracija varijable input za ucitanu cjelobrojnu vrijednost*/
	int input;

	/* size je pocetna velicina dinamicki alociranog bloka,
	index nam govori koji je prvi slobodni element u bloku
	i je brojac za for petlju*/

	int size = 4;
	int size_old;
	int i;
	int index = 0;
	/* inicijalno alociranje memorije. */
	/* Provjeravamo da li je alociranje uspjelo. */
	try {
		numbers = new int[size];
	}
	catch (const bad_alloc& e) {
		// sto da napravi ako alokacija nije uspjela
		cout << "Alokacija nije uspjela:" << e.what() << endl;
		return 0;
	}
	
	/* beskonacna petlja koja se prekida kad
	korisnik unese 0 ili
	korisnik ne unese cjelobrojnu vrijednost*/
	while (1) {

		/* upit */
		cout << "Upisi cijeli broj razlicit od 0 (ili 0 za izlazak): ";
		cin >> input;

		/* ako je ok */
		if ((cin.peek() == '\n' && cin.good()) && input != 0) {
			/* Provjera da li imamo dovoljno dinamicki alocirane memorije.
			Ako ne, povecavamo je 1.5x */
			if (index == size) {
				size_old = size;
				size = size*1.5;
				numbers_old = numbers; //pohraniti staru memoriju
				numbers = new int[size]; //alocirati novu; nismo provjeravali da li smo uspjeli
				for (i = 0;i < size_old;i++) { //prepisati staro polje u novo
					numbers[i] = numbers_old[i];
				}
				delete [] numbers_old; //oslobadanje memorije

				cout << "Realokacija memorijskog bloka. Sada je velicina " << size << "bajta." << endl;
			}

			/* Pospremi cjelobrojnu vrijednost u prvi slobodan element. */
			numbers[index] = input;

			/* index se poveca za 1 kako bi znali sljedece slobodno mjesto za upis. */
			index++;
		} 
		//ako unos nije ok
		else {
			break;
		}

		

	} /* kraj while petlje. */


	  /* poziv funkcije qsort() za uzlazno sortiranje . */
	qsort(numbers, index, sizeof(int), sort);


	/* ispis brojeva u petlji. */
	for (i = 0; i < index; i++) {
		cout << "Vrijednost na mjestu " << i << " je " << numbers[i] << endl;
		
	}


	/* oslobadanje memorije. */
	delete [] numbers;
	numbers = NULL;

	system("pause.exe");
	return 0;

} /* kraj main() funkcije. */


  /* pomocna sort funkcija za qsort */
int sort(const void * a, const void * b) {

	return (*(int*)a - *(int*)b);

} /* kraj sort() funkcije. */